subroutine cdaten(cdate,ndate,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  ! ASTRO Utility routine
  !	Converts the date '01-JAN-1984' in internal code
  ! Arguments
  !	CDATE 	C*(*)	String date			Input
  !	NDATE 	3 I*4	Internal coded date value	Output
  !	ERROR 	L	Logical error flag		Output
  ! Subroutines :
  !	(SIC)
  !	DATJ,JDAT
  ! No commons
  !---------------------------------------------------------------------
  character(len=*):: cdate          !
  integer(kind=4) :: ndate(3)       !
  logical :: error                  !
  ! Global
  integer(kind=4) :: lenc
  ! Local
  character(len=40) :: kdate
  character(len=3) :: cm(0:12),m
  integer(kind=4) :: id, iy, im, idate(7), i, idx1, idx2, iend
  integer(kind=4) :: cd(0:12)
  ! Data
  data cm/'***','JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT',  &
          'NOV','DEC'/
  data cd/0,31,29,31,30,31,30,31,31, 30,31,30,31/
  !------------------------------------------------------------------------
  ! Code
  kdate = cdate
  call sic_upper(kdate)
  iend = lenc(kdate)
  call sic_blanc(kdate, iend)
  if (kdate(1:1) .eq. '*') then
    call utc(idate)
    do i=1, 3
      ndate(i) = idate(i)
    enddo
    return
  endif
  do i=1, iend
    if ((kdate(i:i).lt.'0' .and. kdate(i:i).ne.' ') .or. (kdate(i:i).gt.'9'  &
        .and. kdate(i:i).lt.'A') .or. kdate(i:i).gt.'Z') then
      kdate(i:i) = '-'
    endif
  enddo
  idx1 = index(kdate,'-')
  if (idx1 .le. 1) then
    goto 900
  else
    read(kdate(1:idx1-1),*,err=900) id
    idx2 = idx1 + index(kdate(idx1+1:iend),'-')
    if (idx2.le.idx1+1 .or. idx2.eq.iend) then
      goto 900
    else
      m = kdate(idx1+1:idx2-1)
      do im=1,12
        if (cm(im).eq.m) then
          goto 100
        endif
      enddo
      read(kdate(idx1+1:idx2-1),*,err=900) im
      100         read(kdate(idx2+1:iend),*,err=900) iy
    endif
    if (id.gt.cd(im)) goto 900
  endif
  ndate(1) = iy
  ndate(2) = im
  ndate(3) = id
  return
  !
  ! Wrong date
  900   call astro_message(seve%e,'CDATEN','Date conversion error')
  error=.true.
  return
  !
  entry ndatec(ndate,cdate,error)
  !------------------------------------------------------------------------
  !	Converts the internal code to formatted date
  !------------------------------------------------------------------------
  write(cdate,1001,err=900) ndate(3), cm(ndate(2)), ndate(1)
  1001  format(i2.2,'-',a3,'-',i4.4)
end subroutine cdaten
