subroutine coffse(line,offset,error)
  use gkernel_interfaces
  use class_setup
  !---------------------------------------------------------------------
  ! @ private
  !  Converts the formatted offset angle value in current units to
  ! internal value.
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line    ! command line containing formatted angle
  real(kind=4),     intent(out)   :: offset  ! angle in radian
  logical,          intent(inout) :: error   ! flag
  ! Local
  real(kind=8) :: double
  integer(kind=4) :: n
  !
  n = lenc(line)
  if (line(1:n).eq.'*') return
  !
  call sic_math_dble(line,n,double,error)
  if (error) return
  !
  offset = double/set%fangle
  !
end subroutine coffse
!
subroutine offsec(offset,line)
  use class_setup
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS internal routine
  ! Converts an offset value from radian to a formatted string in
  !	current angle units.
  !---------------------------------------------------------------------
  real(kind=4),     intent(in)  :: offset  ! angle in radian
  character(len=*), intent(out) :: line    ! formatted angle
  ! Local
  real(kind=8) :: double,match
  character(len=4) :: cany
  !
  call bytoch(offset,cany,4)
  if (cany.eq.'ANY ') then
     line = '  *'
  else
     double = dble(offset)*set%fangle
     match  = 0.1*set%tole*set%fangle
     if (abs(double-int(double)).lt.match) then
        if (abs(double).le.9999.99d0) then
           write(line,'(SP,f8.1)') double
        else
           write(line,'(SP,es8.1e1)') double
        endif
     else
        if (abs(double).le.9999.99d0.and.abs(double).ge.0.1d0) then
           write(line,'(SP,f8.1)') double
        else
           write(line,'(SP,es8.1e1)') double
        endif
     endif
  endif
end subroutine offsec
