subroutine keepfi(error)
  use gildas_def
  use gbl_message
  use class_interfaces, except_this=>keepfi
  use class_common
  use class_data
  use class_index
  !---------------------------------------------------------------------
  ! @ private
  ! CLASS support routine for command KEEP
  ! Save profile fit results in the output file.
  ! (Modifies an observation in R onto the output file)
  !---------------------------------------------------------------------
  logical, intent(out) :: error     ! Error flag
  ! Local
  character(len=*), parameter :: rname='KEEP'
  character(len=message_length) :: mess
  !
  if (.not.filein_is_fileout()) then
     call class_message(seve%e,rname,'Input file must equal output file')
     error = .true.
     return
  endif
  !
  call mobs(r,error)   ! Open an obs. of output file to modify it
  if(error) return
  !
  call wgaus(r,error)  ! Save Gaussian fit parameters
  if (error) return
  !
  call class_write_close(r,error)
  if (error) return
  !
  write(mess,'(A,I0,A,I0,A)')  &
    'Observation #',r%head%gen%num,';',r%head%gen%ver,' successfully updated'
  call class_message(seve%i,rname,mess)
  !
end subroutine keepfi
