subroutine output(spec,nspec,lshare,error)
  use class_interfaces
  !---------------------------------------------------------------------
  ! @ obsolete (since 02-Nov-2011)
  ! Compatibility routine with the "old" calling syntax for MIRA
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: spec    ! File name including extension
  integer,          intent(in)  :: nspec   ! Length of SPEC
  logical,          intent(in)  :: lshare  ! Is file to be shared (ignored)
  logical,          intent(out) :: error   ! Logical error flag
  !
  call class_fileout_old(spec,nspec,.false.,error)
end subroutine output
!
subroutine newput(spec,nspec,lsize,lshare,error)
  use classic_api
  use class_interfaces
  !---------------------------------------------------------------------
  ! @ obsolete (since 22-Oct-08)
  ! Compatibility routine with the "old" calling syntax for MIRA
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: spec    ! File name including extension
  integer,          intent(in)  :: nspec   ! Length of SPEC
  integer,          intent(in)  :: lsize   ! Maximum number of observations allowed
  logical,          intent(in)  :: lshare  ! Is file to be shared ? (ignored)
  logical,          intent(out) :: error   ! Logical error flag
  ! Local
  logical :: lsingle ! Should spectra be unique ?
  logical :: lover   ! Overwrite existing file ?
  integer(kind=entry_length) :: lsize8
  !
  lsize8 = lsize
  lsingle = .true.
  lover = .false.
  call class_fileout_new(spec,nspec,lsize8,lsingle,lover,error)
end subroutine newput
!
subroutine iobs (n,entry_num,error)
  use class_interfaces
  use class_data
  !---------------------------------------------------------------------
  ! @ obsolete (since 22-Oct-08)
  ! Compatibility routine for MIRA
  ! Starts the writing of an observation.
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)  :: n          ! Max num of sections to be written (in addition of the data)
  integer(kind=4), intent(out) :: entry_num  ! Entry number of the observation in the output file
  logical,         intent(out) :: error      ! Error flag
  ! Local
  integer(kind=8) :: num8
  !
  call class_write_open(r,n,num8,error)
  entry_num = num8
end subroutine iobs
!
subroutine class_close(error)
  use class_interfaces
  use class_data
  !---------------------------------------------------------------------
  ! @ obsolete (since 02-Nov-2011)
  ! Compatibility routine for MIRA
  ! Close an observation and reopen the output file
  !---------------------------------------------------------------------
  logical, intent(inout) :: error ! Error status
  !
  call class_write_flush(r,error)
end subroutine class_close
!
subroutine message(level,severity,progname,line)
  use gkernel_interfaces
  use class_setup
  !---------------------------------------------------------------------
  ! @ obsolete
  !  OBSOLETE messaging method. Please use the gmessage facility
  ! provided by the kernel.
  !  Output message according to current priority levels, and set the
  ! severity information.
  !---------------------------------------------------------------------
  integer,          intent(in) :: level    ! Priority level controlled by SET LEVEL
  integer,          intent(in) :: severity ! Severity 'I','W','E','F'
  character(len=*), intent(in) :: progname ! Name of calling procedure
  character(len=*), intent(in) :: line     ! Character string
  !
  ! Local variables
  character(len=256) :: linout, string
  character(len=1)   :: severities(4)
  integer :: nl
  integer :: csev
  data severities/'I','W','E','F'/
  !
  ! Do nothing if not serious enough...
  if (set%slev.gt.level .and. set%flev.gt.level) return
  !
  csev = min(max(severity,1),4)
  linout = line
  nl = len(linout)
  call sic_noir(linout,nl)
  string = severities(csev)//'-'//progname//', '//linout(1:nl)
  nl = lenc(string)
  !
  if (set%slev.le.level) then
     call gagout(string)
  endif
!   if (set%flev.le.level) then
!      write(mfile,'(i2,a,a)') level,'-',string(1:nl)
!   endif
  !
end subroutine message
!
subroutine dispoi_obsolet(error)
  use class_data
  use class_setup
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! ANALYSE Support routine for command
  !	DISPLAY
  !	Retrieves and writes gauss fit results for current observation
  !	Continuum method
  !----------------------------------------------------------------------
  ! character(len=*), intent(in)  :: line   ! Command line
  logical,          intent(out) :: error  ! Flag
  ! Local
  character(len=*), parameter :: proc="DISPOI"
  character(len=80) :: chain
  integer :: k,i
  character(len=100) :: mess
  !
  if (.not.r%head%presec(class_sec_poi_id)) then
     write(chain,1005) r%head%gen%num
     call class_message(seve%i,proc,chain)
     return
  endif
  !
  ! Print the results
  write(6,1002) r%head%gen%num,r%head%poi%sigba,r%head%poi%sigra
  if (r%head%poi%sigba.lt.r%head%poi%sigra/1.5 .or. &
       & r%head%poi%sigba.gt.1.5*r%head%poi%sigra) then
     call class_message(seve%i,proc,'Bad or Doubtful FIT')
     write(mess,900)
     call class_message(seve%i,proc,mess)
!!$     write(6,1003)
  else
!!$     write(6,1001)
     call class_message(seve%i,proc,'Fit Results')
     write(mess,900)
     call class_message(seve%i,proc,mess)
  endif
  ! Print only Gaussian parameters
  ! Skip baseline slope
  k=3
  do i=1,max(r%head%poi%nline,1)
     if (r%head%poi%nfit(k+2).ne.0.0) then
        write (mess,910) i,&
             r%head%poi%nfit(k)  *set%fangle,r%head%poi%nerr(k)  *set%fangle,&
             r%head%poi%nfit(k+1)*set%fangle,r%head%poi%nerr(k+1)*set%fangle,&
             r%head%poi%nfit(k+2)*set%fangle,r%head%poi%nerr(k+2)*set%fangle,&
             r%head%poi%nfit(k)/r%head%poi%nfit(k+2)/1.064467
        call class_message(seve%i,proc,mess)
     else
        write (mess,920) i,&
             r%head%poi%nfit(k)  *set%fangle,r%head%poi%nerr(k)  *set%fangle,&
             r%head%poi%nfit(k+1)*set%fangle,r%head%poi%nerr(k+1)*set%fangle,&
             r%head%poi%nfit(k+2)*set%fangle,r%head%poi%nerr(k+2)*set%fangle
        call class_message(seve%i,proc,mess)
     endif
     k=k+3
  enddo
  error = .false.
  !
900 format(' Line      Area               Position           Width           Intensity')
910 format (i5,3x,1pg12.5,' (',0pf7.3,')',2(1x,0pf8.3,' (',0pf7.3,')'),1x,1pg12.5)
920 format (i5,3x,1pg12.5,' (',0pf7.3,')',2(1x,0pf8.3,' (',0pf7.3,')'),1x,'  ****')

1002 format (1x,'Observation ',i0,' RMS of Residuals :  Base = ',   &
       &    1pg10.3,'  Source = ',1pg10.3)
1005 format('No CONTINUUM fit for observation ',i0)
end subroutine dispoi_obsolet
