subroutine com_modify(line,error)
  use gkernel_interfaces
  use phys_const
  use clean_arrays
  use clean_types
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING  Support for command
  !   MODIFY KeyWord Value
  !-----------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  character(len=6) :: rname = 'MODIFY'
  !
  integer, parameter :: nterm=2
  character(len=12) :: term(nterm),chain,key
  data term/'FREQUENCY', 'VELOCITY'/
  integer :: i, iterm, narg, nc
  real(8) :: freq, freq_a,freq_b
  real(4) :: velo
  !
  if (huv%loca%size.ne.0) then
    freq = huv%gil%freq
    velo = huv%gil%voff
  endif
  if (hdirty%loca%size.ne.0) then
    freq = hdirty%gil%freq
    velo = hdirty%gil%voff
  endif
  if (hclean%loca%size.ne.0) then
    freq = hclean%gil%freq
    velo = hclean%gil%voff
  endif
  !
  narg = sic_narg(0)
  do i = 1, narg, 2
    call sic_ke(line,0,i,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
    if (error) return
    !
    select case (key)
    case ('FREQUENCY')
      ! Modify velocity scale according to new rest frequency [MHz]
      call sic_r8(line,0,i+1,freq,.true.,error)
      !
    case ('VELOCITY')
      ! Modify Frequency scale according to new velocity (km/s)
      call sic_r4(line,0,i+1,velo,.true.,error)
      !
    end select
    if (error) return
  enddo
  !
  ! Now which ones ...
  if (huv%loca%size.ne.0) then
    freq_b = gdf_uv_frequency(huv,1.d0)
    Print *,'Frequency Before ',freq_b
    call gdf_modify(huv,velo,freq,error=error)
    freq_a = gdf_uv_frequency(huv,1.d0)
    Print *,'Frequency After ',freq_a
    Print *,'Frequency Difference ',freq_a-freq_b
  endif
  if (hdirty%loca%size.ne.0) then
    call gdf_modify(hdirty,velo,freq,error=error)
  endif
  if (hclean%loca%size.ne.0) then
    call gdf_modify(hclean,velo,freq,error=error)
  endif
  !
end subroutine com_modify

