!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine wipe(line,error)
  use gkernel_interfaces
  !----------------------------------------------------------------------
  ! MAPPING Support routine for command
  !	WIPE [INFO | APER | BEAM | SOLVE [/INTERACTIVE] | ERROR]
  !----------------------------------------------------------------------
  character(len=*), intent(in)  :: line  ! Command line
  logical,          intent(out) :: error ! Returned status
  !
  ! Local variables
  character(len=4) :: rname = 'WIPE'
  integer, parameter :: nactions=5
  character(len=5) :: chain,key,wipe_actions(nactions)
  integer :: iactions,nc
  data wipe_actions/'INFO','APER','BEAM','SOLVE','ERROR'/
  !
  if (sic_present(0,1)) then
     call sic_ke(line,0,1,chain,nc,.true.,error)
     if (error) return
     call sic_ambigs(rname,chain,key,iactions,wipe_actions,nactions,error)
     if (error) return
  else
     key='INFO'
  endif
  if (key.eq.'INFO') then
    call wipe_info(line,error)
  elseif (key.eq.'APER') then
    call wipe_aper(line,error)
  elseif (key.eq.'BEAM') then
    call wipe_beam(line,error)
  elseif (key.eq.'SOLVE') then
    call wipe_solve(line,error)
  elseif (key.eq.'ERROR') then
    call wipe_error(line,error)
 endif
 !
end subroutine wipe
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
