subroutine wipe_info(line,error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! GILDAS:  DECONV Internal routine
  !          Implementation of WIPE deconvolution algorithm,
  !          developed by Lannes et al. at OMP (Toulouse-France)
  !----------------------------------------------------------------------
  character(len=*) line
  logical error
  ! Local
  integer nc,nv
  real(8) :: freq
  character(len=message_length) :: mess
  character(len=4) :: rname = 'WIPE'
  !
  write(mess,100) 'Name of the UV file: ',huv%file(1:lenc(huv%file))
  call map_message(seve%i,rname,mess)
  !
  write(mess,100) 'Image Type:          ',huv%char%type
  call map_message(seve%i,rname,mess)
  !
  write(mess,100) 'Source Name:         ',huv%char%name
  call map_message(seve%i,rname,mess)
  !
  write(mess,100) 'UV line:             ',huv%char%line
  call map_message(seve%i,rname,mess)
  !
  nc = huv%gil%nchan
  write(mess,101) 'Number of channels:  ',nc
  call map_message(seve%i,rname,mess)
  !
  nv = huv%gil%dim(2)
  write(mess,101) 'Number of visibilities: ',nv
  call map_message(seve%i,rname,mess)
  !
  ! Compute observing sky frequency for U,V cell size
  freq = 0.001*gdf_uv_frequency(huv)
  write(mess,102) 'Central frequency:   ',freq,' GHz'
  call map_message(seve%i,rname,mess)
  !
  100   format(a,a)
  101   format(a,i10)
  102   format(a,f12.6,a)
end subroutine wipe_info
