subroutine get_uv(nv,vu,vv,vn,uvt,nc,wcol,scale_x,scale_y)
  ! @ private
  !
  ! Support for WIPE
  integer, intent(in) :: nv,nc
  real, intent(in) :: uvt(nc,nv)
  real, intent(out) :: vu(*),vv(*),vn(*)
  real, intent(in) :: wcol,scale_x,scale_y
  !
  integer i,iw
  !
  iw = 7+3*wcol
  !
  do i=1,nv
    vu(i) = -uvt(1,i)/scale_x
    vv(i) = uvt(2,i)/scale_y
    if (uvt(iw,i).gt.0)  then
      vn(i) = sqrt(1.0/uvt(iw,i))
    elseif (uvt(iw,i).eq.0)  then
      vn(i) = 0.0
    endif
  enddo
end subroutine get_uv
!
subroutine get_uvd(nv,vr,vi,uvt,nc,proc)
  ! @ private
  !
  ! Support for WIPE
  integer, intent(in) :: nv,nc
  integer, intent(in) :: proc  
  real, intent(in) :: uvt(nc,nv)
  real, intent(out) :: vr(nv),vi(nv)
  !
  integer i,ii,ir
  real u,v
  !
  ir = 5+3*proc
  ii = 6+3*proc
  !
  do i=1,nv
    u = -uvt(1,i)
    v = uvt(2,i)
    vr(i) = uvt(ir,i)
    if ((v.lt.0) .or. ((v.eq.0) .and. (u.lt.0))) then
      vi(i) = uvt(ii,i)
    else
      vi(i) = -uvt(ii,i)
    endif
  enddo
end subroutine get_uvd
!
function lenb(a)
  use gbl_message
  integer(kind=1) a(*)
  integer lenb,i
  !
  do i=1,65535
    if (a(i).eq.0) then
      lenb = i-1
      return
    endif
  enddo
  call map_message(seve%e,'LENB','String length overflow')
  lenb = 0
end function lenb
!
subroutine gdf_c2f_plot(action)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !
  !---------------------------------------------------------------------
  integer(kind=1) action(*)
  character(len=*) caction
  !
  character(len=12) what
  include 'gbl_memory.inc'
  integer ln,lenb
  integer(kind=address_length) ip,addr
  !
  what = ' '
  addr = locstr(what)
  ip = bytpnt(addr,membyt)
  ln = lenb(action)
  call bytoby(action,membyt(ip),ln)
  goto 10
  !
  entry gdf_f2f_plot(caction)
  what = caction
  !
  10    continue
  !
  if  (what.eq.'_db') then
    if (.not.gtexist('<BEAM')) then
      call gr_execl('CREATE DIREC <BEAM /GEOMETRY 512 256 /PLOT_PAGE 20 10')
    endif
    call gr_execl('CHANGE DIRECTORY <BEAM')
    call exec_program('@ wipe_plot START BEAM')
  elseif  (what.eq.'_nb') then
    call exec_program('@ wipe_plot CONTINUE BEAM')
  elseif  (what.eq.'_dm') then
    call exec_program('@ wipe_plot END BEAM')
    !
  elseif  (what.eq.'_clean_nm') then
    if (.not.gtexist('<SOL')) then
      call gr_execl('CREATE DIREC <SOL /GEOMETRY 512 256 /PLOT_PAGE 20 10')
    endif
    call exec_program('@ wipe_plot START CLEAN')
  elseif  (what.eq.'_clean_nmres') then
    call exec_program('@ wipe_plot CONTINUE CLEAN')
  elseif  (what.eq.'_clean_res') then
    call exec_program('@ wipe_plot CONTINUE CLEAN')
  elseif  (what.eq.'_clean_sup') then
    continue
    !
  elseif  (what.eq.'_wipe_nm') then
    if (.not.gtexist('<SOL')) then
      call gr_execl('CREATE DIREC <SOL /GEOMETRY 512 256 /PLOT_PAGE 20 10')
    endif
    call exec_program('@ wipe_plot START WIPE')
  elseif  (what.eq.'_wipe_eres') then
    call exec_program('@ wipe_plot CONTINUE WIPE')
  elseif  (what.eq.'_wipe_res') then
    call exec_program('@ wipe_plot CONTINUE WIPE')
  elseif  (what.eq.'_wipe_nmres') then
    continue                   !
  elseif  (what.eq.'_wipe_sup') then
    continue
    !
  elseif  (what.eq.'_mp0') then
    if (.not.gtexist('<ERROR')) then
      call gr_execl('CREATE DIREC <ERROR /GEOMETRY 768 256 /PLOT_PAGE 30 10')
    endif
    call exec_program('@ wipe_plot START ERROR')
  elseif  (what.eq.'_mp1') then
    call exec_program('@ wipe_plot CONTINUE ERROR')
  elseif  (what.eq.'_mp2') then
    call exec_program('@ wipe_plot END ERROR')
  endif
end subroutine gdf_c2f_plot
!
subroutine get_scale (beam,nx,ny,nscale)
  integer nx,ny
  real beam(nx,ny)
  !
  real nscale
  nscale = 1.0/beam(nx/2+1,ny/2+1)
end subroutine get_scale
!
subroutine copy_map(in,out,n,nscale)
  integer n
  real out(n)
  real in(n),nscale
  !
  integer i
  do i =1,n
    out(i) = nscale*in(i)
  enddo
end subroutine copy_map
!
subroutine flux_prep(area,ratio,major,minor)
  real area,ratio,major,minor
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  real sum
  !
  sum = area
  sum = sum*(4.0*log(2.0))/pi
  major = sqrt(sum*ratio)
  minor = major/ratio
end subroutine flux_prep
!
