!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module mrtcal_buffers
  use gildas_def
  use mrtcal_buffer_types
  use mrtcal_setup_types
  !
  ! Current global program behavior
  type(mrtcal_setup_t) :: rsetup
  !
  ! Current image of the imbfits file. SAVE it because Sic variables can
  ! be mapped on it.
  type(imbfits_buffer_t), save :: rfile
  !
  ! Current calibration parameters
  type(calib_t) :: rcalib
  !
  ! Current science data
  type(science_t) :: rscience
  !
end module mrtcal_buffers
!
module mrtcal_sort_var
  use toc_types
  !---------------------------------------------------------------------
  ! Support module for Table-Of-Contents
  !---------------------------------------------------------------------
  !
  ! Mrtcal types, i.e. for fields which needs special decoding (e.g. gag_date:
  ! we won't display the I*4 value, but its translation as a string)
  integer(kind=4), parameter :: mrtcal_ptype_null=0
  integer(kind=4), parameter :: mrtcal_ptype_teles=1
  integer(kind=4), parameter :: mrtcal_ptype_gagdate=2
  integer(kind=4), parameter :: mrtcal_ptype_backend=3
  integer(kind=4), parameter :: mrtcal_ptype_obstype=4
  integer(kind=4), parameter :: mrtcal_ptype_switchmode=5
  integer(kind=4), parameter :: mrtcal_ptype_polarimetry=6
  integer(kind=4), parameter :: mrtcal_ptype_calstatus=7
  integer(kind=4), parameter :: mrtcal_ptype_directory=8
  !
  type(toc_t), target :: mtoc
  !
end module mrtcal_sort_var
!
module mrtcal_messaging
  use gbl_message
  !
  type :: mrtcal_debug_index_message_t
    integer(kind=4) :: alloc   ! Support for MSET DEBUG INDEX ALLOCATION
    integer(kind=4) :: others  ! Support for MSET DEBUG INDEX OTHERS
  end type mrtcal_debug_index_message_t
  !
  type :: mrtcal_debug_calib_message_t
    integer(kind=4) :: alloc   ! Support for MSET DEBUG CALIB ALLOCATION
    integer(kind=4) :: book    ! Support for MSET DEBUG CALIB BOOKKEEPING
    integer(kind=4) :: others  ! Support for MSET DEBUG CALIB OTHERS
  end type mrtcal_debug_calib_message_t
  !
  type :: mrtcal_debug_output_message_t
    integer(kind=4) :: acc   ! Support for MSET DEBUG OUTPUT ACCUMULATION
  end type mrtcal_debug_output_message_t
  !
  type :: mrtcal_debug_message_t
    type(mrtcal_debug_index_message_t)  :: index  ! Support for MSET DEBUG INDEX
    type(mrtcal_debug_calib_message_t)  :: calib  ! Support for MSET DEBUG CALIB
    type(mrtcal_debug_output_message_t) :: output ! Support for MSET DEBUG OUTPUT
    integer(kind=4)                     :: sync   ! Support for MSET DEBUG SYNC
  end type mrtcal_debug_message_t
  !
  type(mrtcal_debug_message_t) :: mseve
  !
end module mrtcal_messaging
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
