subroutine mrtcal_update_command(line,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>mrtcal_update_command
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command MUPDATE
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='MUPDATE'
  integer(kind=4) :: fileid
  !
  ! Sanity checks
  if (kcurr_ix.eq.0) then
    call mrtcal_message(seve%e,rname,'No current entry in memory')
    error = .true.
    return
  endif
  !
  ! We have to update the kcurr_ix-th entry from the input index (IX)
  ! Its contents is already in kentry, and user may have modified it.
  !
  ! Copy back key to index (reverse operation comparing to read time)
  call mrtcal_key_to_index(kentry%head%key,kentry%indx,error)
  if (error)  return
  !
  ! Open file in read-write mode (if not already):
  fileid = ix%idir(kcurr_ix)
  call mrtcal_file_old(fileid,.true.,error)
  if (error)  return
  !
  ! Update current index entry on disk
  call mrtcal_entry_update(ix_files(fileid),kentry,error)
  if (error)  return
  !
  call classic_file_fflush(ix_files(fileid),error)
  if (error)  return
  !
end subroutine mrtcal_update_command
